SystemOrganization addCategory: #'Pier-Wysiwyg'!

WAComponent subclass: #PRWysiwygEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/5/2011 09:39'!
renderContentOn: html
	html html: '<textarea name="msgpost" id="msgpost" cols="50" rows="10">
    <strong>Your</strong> HTML <em>code</em> goes here.<br>
    This text will be pre-loaded in the editor when it is rendered.
</textarea>'.

	html script: 'var myEditor = new YAHOO.widget.Editor("msgpost", {
    height: "300px",
    width: "522px",
    dompath: true, //Turns on the bar at the bottom
    animate: true //Animates the opening, closing and moving of Editor windows
});
myEditor.render();
YAHOO.util.Event.on("somebutton", "click", function() {
    //Put the HTML back into the text area
    myEditor.saveHTML();
 
    //The var html will now have the contents of the textarea
    var html = myEditor.get("element").value;
    alert(html);});
'.

html button
	bePush;
	onClick: 'myEditor.saveHTML();alert(parseHtmlToPierWikiSyntax(myEditor._getDoc().body))';
	with: 'Test Pier syntax conversion'.

	! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/5/2011 09:43'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/2.9.0/build/assets/skins/sam/skin.css'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/yahoo-dom-event/yahoo-dom-event.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/element/element-min.js'.

	"Needed for Menus, Buttons and Overlays used in the Toolbar"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/container/container_core-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/menu/menu-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/button/button-min.js'.
	"Source file for Rich Text Editor"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/editor/editor-min.js'.	
	
	anHtmlRoot bodyAttributes addClass: 'yui-skin-sam'.
	
	anHtmlRoot javascript url: PRWysiwygFileLibrary / #parseHtmlToPierWikiSyntaxJs
	
! !

WAFileLibrary subclass: #PRWysiwygFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 7/5/2011 09:41'!
parseHtmlToPierWikiSyntaxJs
	^ 'var parseHtmlToPierWikiSyntax = function (startNode) {
	var wikiOutput = [];
	
	var surroundingMarkup = function(markup) {
		return function(node) {
			wikiOutput.push(markup);
			walkTheDOM (node.firstChild);
			wikiOutput.push(markup)
		}
	}

	var startLineMarkup = function(markup) {
		return function(node) {
			wikiOutput.push("\n");
			wikiOutput.push(markup);
			walkTheDOM (node.firstChild);
			wikiOutput.push("\n")
		}
	}
	
	var listMarkup = function () {
		return function (node) {
			var parentNodeName = nodeName = node.parentNode.nodeName.toLowerCase();
			if (parentNodeName == ''ul'') {
				startLineMarkup(''#'')(node)
			}
			if (parentNodeName == ''ol'') {
				startLineMarkup(''-'')(node)
			}
		}
	}
	
	var tableMarkup = function () {
		return function () {}
	}
	
	var anchor = function(node) {
		return function(node) {
			if(node.getAttribute("href")) {
				var baseUrl = window.location.host;
				var anchorUrl = node.getAttribute("href");
				var url;

				if(anchorUrl.indexOf(baseURl) == 0) {
					url = anchorUrl.substr(0, baseUrl.length);
				} else {
					url = anchorUrl;
				}

				wikiOutput.push("*");
				walkTheDOM(node.firstChild);
				wikiOutput.push(">");
				wikiOutput.push(node.getAttribute("href"));
				wikiOutput.push("*");
			}
	}
		
	//	wikiOutput.push(''*'');
	}

	var elementToWikiMarkupMappingTable = {
		''b'': surroundingMarkup(''\"\"''),
		''strong'': surroundingMarkup(''\"\"''),
		''i'': surroundingMarkup("\''\''"),
		''em'': surroundingMarkup("\''\''"),
		''hr'': surroundingMarkup("__"),
		''code'': surroundingMarkup("=="),
		''sub'': surroundingMarkup("@@"),
		''sup'': surroundingMarkup("^^"),
		''a'': anchor(),
		''h1'': startLineMarkup (''!!''),
		''h2'': startLineMarkup(''!!!!''), 
		''h3'': startLineMarkup(''!!!!!!''),
		''h4'': startLineMarkup(''!!!!!!!!''), 
		''h5'': startLineMarkup(''!!!!!!!!!!''), 
		''h6'': startLineMarkup(''!!!!!!!!!!!!''),
		''hr'': startLineMarkup(''_''),		
		''li'': listMarkup(),	
		''dl'': startLineMarkup('';''),
		''dd'': startLineMarkup('':''),
		''pre'': startLineMarkup(''=''),
		''table'': tableMarkup()
	}

    var nodeTypes = {
        ELEMENT_NODE: 1,
        ATTRIBUTE_NODE: 2,
        TEXT_NODE: 3,
        CDATA_SECTION_NODE: 4,
        ENTITY_REFERENCE_NODE: 5,
        ENTITY_NODE: 6,
        PROCESSING_INSTRUCTION_NODE: 7,
        COMMENT_NODE: 8,
        DOCUMENT_NODE: 9,
        DOCUMENT_TYPE_NODE: 10,
        DOCUMENT_FRAGMENT_NODE: 11,
        NOTATION_NODE: 12
    }
	
	// the recursive DOM walker
    var walkTheDOM = function (node) {
		if (node === null)
			return ;
			
		console.log(node);

		switch (node.nodeType) {
            case nodeTypes.ELEMENT_NODE:
				var nodeName = node.nodeName.toLowerCase();
				if (elementToWikiMarkupMappingTable.hasOwnProperty (nodeName)) {
					elementToWikiMarkupMappingTable [nodeName](node);
				}
                break;
                
            case nodeTypes.TEXT_NODE:
                wikiOutput.push(node.nodeValue);
                break; 
                
            case nodeTypes.ATTRIBUTE_NODE:
            case nodeTypes.CDATA_SECTION_NODE:
            case nodeTypes.ENTITY_REFERENCE_NODE:
            case nodeTypes.ENTITY_NODE:
            case nodeTypes.PROCESSING_INSTRUCTION_NODE:
            case nodeTypes.COMMENT_NODE:
            case nodeTypes.DOCUMENT_NODE:
            case nodeTypes.DOCUMENT_TYPE_NODE:
            case nodeTypes.DOCUMENT_FRAGMENT_NODE:
            case nodeTypes.NOTATION_NODE:
                break;
			}

		walkTheDOM (node.nextSibling);
    }
	walkTheDOM (startNode.firstChild);
	return wikiOutput.join('''');
}'! !
